SystemOrganization addCategory: #'GMF-GraphicModel'!

Object subclass: #Diagram
	instanceVariableNames: 'name file lastAccess layout saved'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GMF-GraphicModel'!

!Diagram class methodsFor: 'instance creation' stamp: 'RostislavNovk 10/27/2013 18:05'!
newName: xName
	^ super new
		initialize;
		name: xName;
		yourself! !

!Diagram methodsFor: 'layoutMethods' stamp: 'RostislavNovk 10/28/2013 15:23'!
addItem: xItem
	layout add: xItem.! !

!Diagram methodsFor: 'accessing' stamp: 'RostislavNovk 10/28/2013 17:41'!
draw
	layout do:[:l | l draw. ].! !

!Diagram methodsFor: 'accessing' stamp: 'RostislavNovk 10/24/2013 15:21'!
file
	^file! !

!Diagram methodsFor: 'accessing' stamp: 'RostislavNovk 10/24/2013 15:22'!
file: xFile
	file := xFile.! !

!Diagram methodsFor: 'layoutMethods' stamp: 'RostislavNovk 10/28/2013 15:23'!
getItem: itemName
	layout do: [ :x | x name == itemName ].! !

!Diagram methodsFor: 'initialize-release' stamp: 'RostislavNovk 10/28/2013 15:23'!
initialize
	lastAccess := TimeStamp now.
	"layout := XYLayout new."
	"file := FileHandle new."
	saved := false.
	layout := OrderedCollection new.! !

!Diagram methodsFor: 'accessing' stamp: 'RostislavNovk 10/24/2013 15:24'!
isSaved
	^saved! !

!Diagram methodsFor: 'accessing' stamp: 'RostislavNovk 10/24/2013 15:21'!
lastAccess
	^lastAccess! !

!Diagram methodsFor: 'accessing' stamp: 'RostislavNovk 10/24/2013 15:20'!
name
	^name! !

!Diagram methodsFor: 'accessing' stamp: 'RostislavNovk 10/24/2013 15:20'!
name: xName
	name := xName.! !

!Diagram methodsFor: 'private' stamp: 'RostislavNovk 10/27/2013 20:43'!
refreshLastAccess
	lastAccess := TimeStamp now.! !

!Diagram methodsFor: 'layoutMethods' stamp: 'RostislavNovk 10/28/2013 15:23'!
removeItem: xItem
	layout remove:[:x | x == xItem ].! !

!Diagram methodsFor: 'private' stamp: 'RostislavNovk 10/27/2013 20:31'!
saved: xSave
	saved := xSave.! !

Object subclass: #EndOfLine
	instanceVariableNames: 'x y type'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GMF-GraphicModel'!

!EndOfLine methodsFor: 'accessing' stamp: 'RostislavNovk 10/27/2013 21:35'!
draw
	type draw.! !

!EndOfLine methodsFor: 'accessing' stamp: 'RostislavNovk 10/24/2013 15:25'!
setPositionX: xX Y: xY
 	x := xX.
	y := xY.! !

Object subclass: #Item
	instanceVariableNames: 'name x y'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GMF-GraphicModel'!

Item subclass: #Box
	instanceVariableNames: 'sqaure layout methods variables type line1 line2'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GMF-GraphicModel'!

!Box class methodsFor: 'instance creation' stamp: 'RostislavNovk 10/28/2013 17:31'!
newName: xName type: xType
	^ (super newName: xName)
		initialize;
		type: xType;
		resetLayout;
		yourself! !

!Box class methodsFor: 'instance creation' stamp: 'RostislavNovk 10/28/2013 17:31'!
newName: xName type: xType x: xX y: xY
	^ (super newName: xName)
		initialize;
		type: xType;
		setPositionX: xX Y: xY;
		resetLayout;
		yourself! !

!Box methodsFor: 'accessing' stamp: 'RostislavNovk 10/28/2013 17:22'!
addMethod: xText
	methods add: xText.
	layout add: ( MyText newText: xText ) afterIndex: line2+1.! !

!Box methodsFor: 'accessing' stamp: 'RostislavNovk 10/28/2013 17:22'!
addVariable: xText
	variables add: xText.
	layout add: ( MyText newText: xText ) afterIndex: line1+1.
	line2 := line2+1.! !

!Box methodsFor: 'accessing' stamp: 'RostislavNovk 10/28/2013 17:42'!
draw
	Transcript show: 'Box ', name; cr.
	"sqaure draw.
	layout draw."
	layout do:[:l | l draw ].! !

!Box methodsFor: 'initialize-release' stamp: 'RostislavNovk 10/28/2013 17:30'!
initialize
	methods := OrderedCollection new.
	variables := OrderedCollection new.
	layout := OrderedCollection new.
	"layout add: Line newX:  Y:  X2:  Y2:"
	"square := Square newX: 0 Y: 0 X2: 25 Y2: 25"
	line1 := 2.
	line2 := 3.! !

!Box methodsFor: 'accessing' stamp: 'RostislavNovk 10/28/2013 17:34'!
methods
	^methods copy! !

!Box methodsFor: 'initialize-release' stamp: 'RostislavNovk 10/28/2013 17:32'!
resetLayout
	layout reset.
	layout add: (MyText newText: '<<',type,'>>').
	layout add: (MyText newText: name ).
	layout add: (Line newX: 0 Y: 0 X2: 15 Y2: 25 ).
	layout add: (Line newX: 0 Y: 0 X2: 15 Y2: 25 ).! !

!Box methodsFor: 'accessing' stamp: 'RostislavNovk 10/28/2013 17:23'!
type: xType
	type := xType.! !

!Box methodsFor: 'accessing' stamp: 'RostislavNovk 10/28/2013 17:34'!
variables
	^variables copy! !

Item subclass: #GroupOfLines
	instanceVariableNames: 'leftBox rightBox leftText middleText rightText lines leftArrow rightArrow'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GMF-GraphicModel'!

!GroupOfLines class methodsFor: 'instance creation' stamp: 'RostislavNovk 10/27/2013 21:33'!
newName: xName leftBox: xBox rightBox: xxBox
	^(super newName: xName )
		initialize;
		leftBox: xBox;
		rightBox: xxBox;
		lines: (Line newX: (xBox x) Y: (xBox y)  X2: (xxBox x) Y2: (xxBox y));
		yourself.! !

!GroupOfLines methodsFor: 'accessing' stamp: 'RostislavNovk 10/28/2013 17:42'!
draw
	Transcript show: 'GroupOfLines: ', name; cr.
	lines do:[:l | l draw ].
	"leftArrow draw.
	rightArrow draw."! !

!GroupOfLines methodsFor: 'initialize-release' stamp: 'RostislavNovk 10/27/2013 21:29'!
initialize
	lines := OrderedCollection new.! !

!GroupOfLines methodsFor: 'accessing' stamp: 'RostislavNovk 10/27/2013 21:28'!
leftArrow: xArrow
	leftArrow := xArrow.! !

!GroupOfLines methodsFor: 'accessing' stamp: 'RostislavNovk 10/27/2013 21:25'!
leftBox
	^leftBox.! !

!GroupOfLines methodsFor: 'accessing' stamp: 'RostislavNovk 10/27/2013 21:25'!
leftBox: xBox
	leftBox := xBox.! !

!GroupOfLines methodsFor: 'accessing' stamp: 'RostislavNovk 10/27/2013 21:25'!
leftText
	^leftText! !

!GroupOfLines methodsFor: 'accessing' stamp: 'RostislavNovk 10/27/2013 21:26'!
leftText: xText
	leftText := xText.! !

!GroupOfLines methodsFor: 'accessing' stamp: 'RostislavNovk 10/27/2013 21:30'!
lines
	^lines copy.! !

!GroupOfLines methodsFor: 'accessing' stamp: 'RostislavNovk 10/27/2013 21:30'!
lines: xLine
	lines add: xLine.! !

!GroupOfLines methodsFor: 'accessing' stamp: 'RostislavNovk 10/27/2013 21:27'!
middleText
	^middleText.! !

!GroupOfLines methodsFor: 'accessing' stamp: 'RostislavNovk 10/27/2013 21:26'!
middleText: xText
	middleText := xText.! !

!GroupOfLines methodsFor: 'accessing' stamp: 'RostislavNovk 10/27/2013 21:28'!
rightArrow: xArrow
	rightArrow := xArrow.! !

!GroupOfLines methodsFor: 'accessing' stamp: 'RostislavNovk 10/27/2013 21:25'!
rightBox
	^rightBox.! !

!GroupOfLines methodsFor: 'accessing' stamp: 'RostislavNovk 10/27/2013 21:25'!
rightBox: xBox
	rightBox := xBox.! !

!GroupOfLines methodsFor: 'accessing' stamp: 'RostislavNovk 10/27/2013 21:26'!
rightText
	^rightText.! !

!GroupOfLines methodsFor: 'accessing' stamp: 'RostislavNovk 10/27/2013 21:26'!
rightText: xText
	rightText := xText.! !

!Item class methodsFor: 'instance creation' stamp: 'RostislavNovk 10/27/2013 20:39'!
newName: xName
	^ super new
		initialize;
		name: xName;
		yourself! !

!Item methodsFor: 'public' stamp: 'RostislavNovk 10/24/2013 15:25'!
draw
	^self subclassResponsibility.! !

!Item methodsFor: 'private' stamp: 'RostislavNovk 10/27/2013 20:40'!
initialize
	x := 0.
	y := 0.! !

!Item methodsFor: 'public' stamp: 'RostislavNovk 10/27/2013 20:38'!
name
	^name! !

!Item methodsFor: 'private' stamp: 'RostislavNovk 10/27/2013 20:39'!
name: xName
	name := xName.! !

!Item methodsFor: 'public' stamp: 'RostislavNovk 10/24/2013 15:26'!
setPositionX: xX Y: xY
	x := xX.
	y := xY.! !

!Item methodsFor: 'public' stamp: 'RostislavNovk 10/27/2013 20:38'!
x
	^x! !

!Item methodsFor: 'public' stamp: 'RostislavNovk 10/27/2013 20:38'!
y
	^y! !

Item subclass: #Line
	instanceVariableNames: 'x1 y1 x2 y2'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GMF-GraphicModel'!

!Line class methodsFor: 'instance creation' stamp: 'RostislavNovk 10/27/2013 21:22'!
newX: xX Y: yY X2: xxX Y2: yyY
	^(super newName: 'Line')
		initialize;
		setLeftPositionX: xX Y: yY;
		setRightPositionX: xxX Y: yyY;
		yourself.! !

!Line methodsFor: 'accessing' stamp: 'RostislavNovk 10/28/2013 15:57'!
draw
	Transcript show: '-----------------'; cr.! !

!Line methodsFor: 'initialize-release' stamp: 'RostislavNovk 10/27/2013 21:11'!
initialize
	x1 := 0.
	y1 := 0.
	x2 := 0.
	y2 := 0.! !

!Line methodsFor: 'accessing' stamp: 'RostislavNovk 10/27/2013 21:21'!
setLeftPositionX: xX Y: xY
	x1 := xX.
	y1 := xY.
	self setPosition.! !

!Line methodsFor: 'accessing' stamp: 'RostislavNovk 10/27/2013 21:21'!
setPosition
	 | temp temp2 |
	temp := ((x1+x2)/2).
	temp2 := ((y1+y2)/2).
	super setPositionX: temp Y: temp2. ! !

!Line methodsFor: 'accessing' stamp: 'RostislavNovk 10/27/2013 21:21'!
setRightPositionX: xX Y: xY
	x2 := xX.
	y2 := xY.
	self setPosition.! !

Item subclass: #MyText
	instanceVariableNames: 'text font size'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GMF-GraphicModel'!

!MyText class methodsFor: 'instance creation' stamp: 'RostislavNovk 10/27/2013 21:08'!
newText: xText
	^ (super newName: xText)
		initialize;
		strText: xText;
		yourself! !

!MyText methodsFor: 'accessing' stamp: 'RostislavNovk 10/28/2013 17:19'!
draw
	Transcript show: text; cr.! !

!MyText methodsFor: 'accessing' stamp: 'RostislavNovk 10/24/2013 15:28'!
font
	^font! !

!MyText methodsFor: 'accessing' stamp: 'RostislavNovk 10/24/2013 15:28'!
font: xFont
	font := xFont.! !

!MyText methodsFor: 'initialize-release' stamp: 'RostislavNovk 10/27/2013 21:06'!
initialize
	size := 12.
	font := 'Arial'.! !

!MyText methodsFor: 'accessing' stamp: 'RostislavNovk 10/24/2013 15:29'!
size 
	^size.! !

!MyText methodsFor: 'accessing' stamp: 'RostislavNovk 10/24/2013 15:29'!
size: xSize
	size := xSize.! !

!MyText methodsFor: 'accessing' stamp: 'RostislavNovk 10/27/2013 21:04'!
strText
	^text! !

!MyText methodsFor: 'accessing' stamp: 'RostislavNovk 10/27/2013 21:04'!
strText: xText
	text := xText.! !
